;****************************************************************
;Program pracuje jako dekadick ta od 0 do 9999 s periodou   *
;inkrementace piblin rovnou 1s				*
;---------------------------------------------------------------*
;Nastaven EDUKITu BETA:				        *	
;DISPLAY: ON		                                        * 
;ostatn: OFF                                                   *
;---------------------------------------------------------------*
;autor: ASIX, Tom Musil		datum: 19.11.2002       *
;****************************************************************
w       equ     0               ;parametr instrukc
f       equ     1               ;parametr instrukc
tmr0    equ     0x01
optreg  equ     0x01
pcl     equ     0x02 
status  equ     0x03	
porta   equ     0x05		;adresa portu A
trisa   equ     0x05
portb   equ     0x06		;adresa portu B
trisb   equ     0x06
intcon  equ     0x0B 
disp1   equ     0x20            ;pamt pro 1 sedmisegmentovku
disp2   equ     0x21            ;pamt pro 2 sedmisegmentovku
disp3   equ     0x22            ;pamt pro 3 sedmisegmentovku
disp4   equ     0x23            ;pamt pro 4 sedmisegmentovku
rot1    equ     0x24		;pomocn registr
rot2    equ     0x25		
rot3    equ     0x26		
rot4    equ     0x27		
cntrot  equ     0x28		;pomocn registr
sec     equ     0x29            ;ta 1 sekundy
;*******************************************************
#define RP0     status,5 
#define T0IF    intcon,2        ;indikace peteen TMR0
#define C       status,0
#define STR     portb,6		;signl strobe obvodu 4094
#define DATA    portb,7		;signl data obvodu 4094
#define CLK     portb,4 	;hodinov signl obvodu 4094
;*******************************************************
	list    p = 16F627 
	__config 0x3F71         ;nastaven konfigurace
;*******************************************************
	org     0x0000
	goto    Main
;******************************************************* 
Tab1    addwf   pcl,f           ;pite w k tai instrukc
	retlw   B'00000011'     ; zobraz 0
	retlw   B'10011111'     ; zobraz 1
	retlw   B'00100101'     ; zobraz 2
	retlw   B'00001101'     ; zobraz 3
	retlw   B'10011001'     ; zobraz 4
	retlw   B'01001001'     ; zobraz 5
	retlw   B'01000001'     ; zobraz 6
	retlw   B'00011111'     ; zobraz 7
	retlw   B'00000001'     ; zobraz 8
	retlw   B'00001001'     ; zobraz 9
	retlw   B'11111111'	; przdn displej
;*******************************************************
Counter clrf    sec             ;vynuluje registr sec
	incf    disp1,f         ;pite 1 k registru Disp1
	movlw   0x0A 
	subwf   disp1,w         ;odete od Disp1 destku a ulo ;do W
	btfss   C               ;je-li C=1, Disp1 petekl pes 9
	goto    Count_A 
	clrf    disp1 
	incf    disp2,f         ;pite 1 k registru Disp2
	movlw   0x0A 
	subwf   disp2,w         ;odete od Disp2 destku a ulo ;do W
	btfss   C               ;je-li C=1, Disp2 petekl pes 9
	goto    Count_A 
	clrf    disp2 
	incf    disp3,f         ;pite 1 k registru Disp3
	movlw   0x0A 
	subwf   disp3,w         ;odete od Disp3 destku a ulo ;do W
	btfss   C               ;je-li C=1, Disp3 petekl pes 9
	goto    Count_A 
	clrf    disp3 
	incf    disp4,f         ;pite 1 k registru Disp4
	movlw   0x0A 
	subwf   disp4,w         ;odete od Disp4 destku a ulo ;do W
	btfss   C               ;je-li C=1, Disp4 petekl pes 9
	goto    Count_A 
	clrf    disp4 
Count_A return 
;*******************************************************
Displej bcf     STR		;strobe do L 
	movf    disp1,w		;podle hodnoty v disp1 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot1
	movf    disp2,w		;podle hodnoty v disp2 se vygeneruje
	call    Tab1		;kd znaku
	movwf   rot2
	movf    disp3,w
	call    Tab1
	movwf   rot3
	movf    disp4,w
	call    Tab1
	movwf   rot4
	movlw   0x20		;smyka probhne 32x (4 sedmisegmentovky
	movwf   cntrot		;po 8 bitech)
Disp_A  rrf     rot1,f		;rotace 32 bitovho registru (4x8)
	rrf     rot2,f
	rrf     rot3,f
	rrf     rot4,f
	bsf     DATA		;data do H
	btfss   C
	bcf     DATA		;pokud je C=L, pak data do L
	bcf     CLK		;hodiny do L
	nop
	bsf     CLK		;nbn hrana hodin (zpis dat)
	decfsz  cntrot,f	;testovn konce smyky	
	goto    Disp_A		;skok na zatek smyky
	bsf     STR		;strobe do L (pepsn dat z registru
	return 			;obvod 4094 na vstup)
;*******************************************************
Main    bsf     RP0             ;strnka 1 pamti RAM
	movlw   B'11010011' 
	movwf   optreg          ;konfigurace TMR0 a peddliky
	movlw   B'00101111' 
	movwf   trisb           ;DATA, CLK a STR jsou vstupy
	bcf     RP0             ;strnka 0 pamti RAM
	clrf    disp1           ;vynuluje registr Disp1
	clrf    disp2           
	clrf    disp3           
	clrf    disp4           
;*******************************************************
Main_A  call    Displej         ;podprogram zobrazen na displeji
	bcf     T0IF            ;vynulovn bitu T0IF
	clrf    tmr0            ;vynulovn TMR0 a peddliky
Main_B  btfss   T0IF            ;testovn bitu T0IF
	goto    Main_B 
	incf    sec,f           ;pite 1 k registru tae sekund
	movlw   0xC7 
	subwf   sec,w           ;odete od sec 199 a ulo do W
	btfsc   C               ;je li C=1, registr sec nepetekl
	call    Counter
	goto    Main_A          ;sko na zatek smyky
;*******************************************************
	end