;****************************************************************
;Program porovnv hodnotu TRIM2 a TRIM3, pokud je TRIM2 > TRIM3*
;rozsvt se LED, v opanm ppad LED zhasne   		*
;---------------------------------------------------------------*
;Nastaven EDUKITu BETA:				        *	
;TRIM2, TRIM3, LED: ON                                          * 
;ostatn: OFF                                                   *
;---------------------------------------------------------------*
;autor: ASIX, Tom Musil		datum: 19.11.2002       *
;****************************************************************
w       equ     0               ;parametr instrukc
f       equ     1               ;parametr instrukc
status  equ     0x03            ;status je na adrese 0x03
porta   equ     0x05		;adresa portu A 
trisa   equ     0x05            
cmcon   equ     0x1F		;dc registr bloku kompartor 
;*******************************************************
#define RP0     status,5 
#define RP1     status,6
#define LED     porta,4		;vstup kontroln LED diody
#define C2OUT   cmcon,7		;vstup druhho kompartoru
;*******************************************************
	list    p = 16F627 
	__config 0x3F71         ;nastaven konfigurace
;*******************************************************
bnk0    macro
	bcf     RP0		;nastav banku 0
	bcf     RP1
	endm
bnk1    macro
	bsf     RP0		;nastav banku 1
	bcf     RP1
	endm
;******************************************************* 
	org     0x0000
	goto    Init
;*******************************************************
Init    bnk1			
	movlw   B'11101111'	;pin kontroln LED je vstupn
	movwf   trisa
	bnk0
	movlw   B'00100101'
	movwf   cmcon 		;konfigurace kompartor	
;*******************************************************
Main    btfss   C2OUT		;je-li vstup kompartoru L
	bsf     LED		;LED zhasne
	btfsc   C2OUT		;je-li vstup kompartoru H
	bcf     LED 		;LED se rozsvt
	goto    Main           	;sko na zatek smyky
;*******************************************************
	end